#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "CSurface.h"

CSurface::CSurface(CFrame &frame, int width, int height) : CBitmap(frame, width, height) {

	int i;
	
	surface = new unsigned char[width * height];
	
	for (i = 0; i < 256; i++)
		setPaletteEntry(i, i, 255 - i, 255 - i);
	
	for (i = 0; i < width * height; i++)
		surface[i] = i;
}

CSurface::~CSurface() {
	
	delete surface;
}

unsigned char *CSurface::getSurface() {
	
	return surface;
}

void CSurface::setPaletteEntry(int i, unsigned char r, unsigned char g, unsigned char b) {
	
	palette[i].r = r;
	palette[i].g = g;
	palette[i].b = b;
}

void CSurface::commitBitmap() {
	
	HDC hdc;
	BITMAPINFO *bmi;
	int i;
	
	bmi = (BITMAPINFO*)new unsigned char[sizeof(BITMAPINFOHEADER) + (256 * sizeof(RGBQUAD))];

	memset(bmi, 0, sizeof(BITMAPINFOHEADER));
	
	for (i = 0; i < 256; i++) {
		
		bmi->bmiColors[i].rgbRed = palette[i].r;
		bmi->bmiColors[i].rgbGreen = palette[i].g;
		bmi->bmiColors[i].rgbBlue = palette[i].b;
		bmi->bmiColors[i].rgbReserved = 0;
	}
	
	bmi->bmiHeader.biSize = sizeof(bmi->bmiHeader);
	bmi->bmiHeader.biWidth = getWidth();
	bmi->bmiHeader.biHeight = -getHeight();
	bmi->bmiHeader.biPlanes = 1;
	bmi->bmiHeader.biBitCount = 8;
	bmi->bmiHeader.biCompression = BI_RGB;
	bmi->bmiHeader.biSizeImage = 0;
	bmi->bmiHeader.biXPelsPerMeter = 3780;
	bmi->bmiHeader.biYPelsPerMeter = 3780;
	bmi->bmiHeader.biClrUsed = 0;
	bmi->bmiHeader.biClrImportant = 0;

	hdc = GetDC(0);
	SetDIBits(hdc, (HBITMAP)pHandle, 0, height, surface, bmi, DIB_RGB_COLORS);
	ReleaseDC(0, hdc);
	
	delete bmi;
}
