#ifndef __VSTEDITOR_H__
#define __VSTEDITOR_H__

#include "vstgui.h"
#include "CSurface.h"
#include "synthgui.h"

class VSTEditor : public AEffGUIEditor, public CControlListener {
	
public:
	VSTEditor(AudioEffect *effect);
	virtual ~VSTEditor();

public:
	virtual long open(void *ptr);
	virtual void close();

	virtual void setParameter (long index, float value);
	virtual void valueChanged (CDrawContext* context, CControl* control);
	void mouseClick(CFrame *frame, CDrawContext *pContext);
	void mouseRelease(CFrame *frame, CDrawContext *pContext);
	void mouseMove(CFrame *frame, CDrawContext *pContext, int x, int y);
	SynthGUI *getSynthGUI();
	void redraw();

private:
	void setPalette();
	// Bitmap
	CSurface *hBackground;

	// Others
	bool bOpened;
	SynthGUI *synthgui;
};

#endif
