//-------------------------------------------------------------------------------------------------------
// VST Plug-Ins SDK
// Example AGain (VST 1.0)
// Stereo plugin which applies a Gain [-oo, 0dB]
//  2003, Steinberg Media Technologies, All Rights Reserved
//-------------------------------------------------------------------------------------------------------

#ifndef __VSTPLUGIN_H
#define __VSTPLUGIN_H

#include "audioeffectx.h"

//-------------------------------------------------------------------------------------------------------
class VSTPlugin : public AudioEffectX
{
public:
	VSTPlugin (audioMasterCallback audioMaster);
	~VSTPlugin ();

	// Processes
	virtual void process (float **inputs, float **outputs, long sampleFrames);
	virtual void processReplacing (float **inputs, float **outputs, long sampleFrames);
	virtual long processEvents (VstEvents* events);
	virtual void setBlockSize(long blockSize);

	// Program
	virtual void setProgramName (char *name);
	virtual void getProgramName (char *name);
	virtual long getProgram ();
	virtual void setProgram (long program);

	// Parameters
	virtual void setParameter (long index, float value);
	virtual float getParameter (long index);
	virtual void getParameterLabel (long index, char *label);
	virtual void getParameterDisplay (long index, char *text);
	virtual void getParameterName (long index, char *text);

	virtual bool getEffectName (char* name);
	virtual bool getVendorString (char* text);
	virtual bool getProductString (char* text);
	virtual long getVendorVersion () { return 1000; }

	virtual void resume(void);	
	virtual VstPlugCategory getPlugCategory () { return kPlugCategEffect; }

protected:
	float fGain;
	char programName[32];
	float *buffer;
};

#endif
